#pragma once

#include "node.hpp"
#include "student_points.hpp"
#include "user_grade_boundaries.hpp"

#include <QList>

struct UserPointConfig;
struct UserGradeConfig;
struct DynexiteExam;

template <GradingType Grading>
struct GradeList
    : Node<UserPointConfig, UserGradeConfig, UserGradeBoundaries<Grading>,
           DynexiteExam, StudentPoints<Grading>> {
    using Node<UserPointConfig, UserGradeConfig, UserGradeBoundaries<Grading>,
               DynexiteExam, StudentPoints<Grading>>::Node;

    void recalculate();

    QList<Grade> mGrades{};
};
