#pragma once

#include "applied_bonus_points.hpp"
#include "dynexite_exam.hpp"
#include "node.hpp"

#include "util/points.hpp"

#include <QList>

struct UserPointConfig;
struct DynexiteExam;

template <GradingType Grading>
struct StudentPoints : Node<DynexiteExam, AppliedBonusPoints<Grading>> {
    using Node<DynexiteExam, AppliedBonusPoints<Grading>>::Node;

    void recalculate();

    QList<Points> mPointsWithBonus{};
};

struct CombinedStudentPoints : Node<StudentPoints<GradingType::Closed>,
                                    StudentPoints<GradingType::Open>> {

    using Node<StudentPoints<GradingType::Closed>,
               StudentPoints<GradingType::Open>>::Node;

    void recalculate();

    QList<Points> mPointsWithBonus{};
};
