#pragma once

#include "util/storage_helper.hpp"

#include <QObject>
#include <QTableWidget>
#include <QTimer>
#include <QWidget>

class StudentsTab : public QWidget {
    Q_OBJECT

public:
    explicit StudentsTab(QWidget *parent = nullptr) noexcept;

    /**
     * \brief Adapt the row/column size to the new font size
     */
    void handleResize() noexcept;

public slots:
    /**
     * \brief Update number of column and rows, the student ids and the points.
     */
    void pointsChanged() noexcept;

    /**
     * \brief Update grades.
     */
    void gradesChanged(const EnumStorage<bool> &changedTypes);

private slots:
    void resizeTable() noexcept;

private:
    QTableWidget mTable;

    QTimer mResizeTimer;
};
